&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v8r12 GUI
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS C-Win 
/*------------------------------------------------------------------------

  File: 

  Description: 
  
     Example of how to use SHFileOperation to copy, move or delete files
     leveraging the common dialogs which microsoft provide as part of the 
     move, copy, and delete operations.


  Input Parameters:
      <none>

  Output Parameters:
      <none>

  Author:  Todd G. Nist

  Created: 10/12/99

------------------------------------------------------------------------*/
/*          This .W file was created with the Progress UIB.             */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/*
Type SHFILEOPSTRUCT   
    hWnd        As Long   
    wFunc       As Long
    pFrom       As long  
    pTo         As long   
    fFlags      As Integer
    fAborted    As Boolean   
    hNameMaps   As Long   
    sProgress   As long 
End Type
*/


/* Parameters Definitions ---                                           */
&GLOB FO_MOVE   1
&GLOB FO_COPY   2
&GLOB FO_DELETE 3
&GLOB FO_RENAME 4

&GLOB FOF_SILENT              4
&GLOB FOF_RENAMEONCOLLISION   8
&GLOB FOF_NOCONFIRMATION     16
&GLOB FOF_SIMPLEPROGRESS    256
&GLOB FOF_ALLOWUNDO          64

/* Local Variable Definitions ---                                       */

define var iRetCode     as  int     no-undo.


PROCEDURE SHFileOperationA EXTERNAL "Shell32.dll":
  DEFINE INPUT PARAMETER  lpFileOp  AS  LONG.
  DEFINE RETURN PARAMETER iRetCode  AS  LONG.
END.


PROCEDURE FormatMessageA EXTERNAL 'kernel32':U:
  define input parameter  dwFlags as long.
  define input parameter  lpSource as long.
  define input parameter  dwMessageID as LONG. 
  define input parameter  dwLanguageID as LONG. 
  define output parameter lpBuffer as char.
  define input parameter  nSize as long.
  define input parameter  lpArguments as long.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Window

/* Name of first Frame and/or Browse and/or first Query                 */
&Scoped-define FRAME-NAME DEFAULT-FRAME

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS RECT-1 cFileFrom cFileTo cTitle cDeleteFile ~
btnCopyFiles btnDeleteFile 
&Scoped-Define DISPLAYED-OBJECTS cFileFrom cFileTo cTitle cDeleteFile 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME


/* ************************  Function Prototypes ********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD ShowError C-Win 
FUNCTION ShowError RETURNS LOGICAL
  (INPUT piErrorCode    AS  INTEGER) FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* ***********************  Control Definitions  ********************** */

/* Define the widget handle for the window                              */
DEFINE VAR C-Win AS WIDGET-HANDLE NO-UNDO.

/* Definitions of the field level widgets                               */
DEFINE BUTTON btnCopyFiles 
     LABEL "Copy Files" 
     SIZE 15 BY 1.14.

DEFINE BUTTON btnDeleteFile 
     LABEL "Delete Files" 
     SIZE 15 BY 1.14.

DEFINE VARIABLE cDeleteFile AS CHARACTER FORMAT "X(256)":U INITIAL "c:~\temp~\*.*" 
     VIEW-AS FILL-IN 
     SIZE 58 BY 1 NO-UNDO.

DEFINE VARIABLE cFileFrom AS CHARACTER FORMAT "X(256)":U INITIAL "d:~\v8dev~\db~\*.*" 
     VIEW-AS FILL-IN 
     SIZE 58 BY 1 NO-UNDO.

DEFINE VARIABLE cFileTo AS CHARACTER FORMAT "X(256)":U INITIAL "c:~\temp~\" 
     VIEW-AS FILL-IN 
     SIZE 58 BY 1 NO-UNDO.

DEFINE VARIABLE cTitle AS CHARACTER FORMAT "X(256)":U INITIAL "MyApp Installation" 
     VIEW-AS FILL-IN 
     SIZE 58 BY 1 NO-UNDO.

DEFINE RECTANGLE RECT-1
     EDGE-PIXELS 2 GRAPHIC-EDGE  NO-FILL 
     SIZE 62.4 BY .1.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME DEFAULT-FRAME
     cFileFrom AT ROW 1.71 COL 3 NO-LABEL
     cFileTo AT ROW 3.62 COL 3 NO-LABEL
     cTitle AT ROW 5.52 COL 3 NO-LABEL
     cDeleteFile AT ROW 7.43 COL 3 NO-LABEL
     btnCopyFiles AT ROW 9.24 COL 3
     btnDeleteFile AT ROW 9.24 COL 19
     "Delete File Specification" VIEW-AS TEXT
          SIZE 27 BY .62 AT ROW 6.71 COL 3
     RECT-1 AT ROW 8.86 COL 1
     "Copy File Specification" VIEW-AS TEXT
          SIZE 27 BY .62 AT ROW 1 COL 3
     "To File Specification" VIEW-AS TEXT
          SIZE 27 BY .62 AT ROW 2.91 COL 3
     "Dialog Title" VIEW-AS TEXT
          SIZE 27 BY .62 AT ROW 4.81 COL 3
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 62.4 BY 9.48.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Window
   Allow: Basic,Browse,DB-Fields,Window,Query
   Other Settings: COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
IF SESSION:DISPLAY-TYPE = "GUI":U THEN
  CREATE WINDOW C-Win ASSIGN
         HIDDEN             = YES
         TITLE              = "SHFileOperation Example"
         HEIGHT             = 9.38
         WIDTH              = 62.2
         MAX-HEIGHT         = 16
         MAX-WIDTH          = 80
         VIRTUAL-HEIGHT     = 16
         VIRTUAL-WIDTH      = 80
         RESIZE             = yes
         SCROLL-BARS        = no
         STATUS-AREA        = no
         BGCOLOR            = ?
         FGCOLOR            = ?
         KEEP-FRAME-Z-ORDER = yes
         THREE-D            = yes
         MESSAGE-AREA       = no
         SENSITIVE          = yes.
ELSE {&WINDOW-NAME} = CURRENT-WINDOW.
/* END WINDOW DEFINITION                                                */
&ANALYZE-RESUME


/* ***************  Runtime Attributes and UIB Settings  ************** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW C-Win
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME DEFAULT-FRAME
                                                                        */
/* SETTINGS FOR FILL-IN cDeleteFile IN FRAME DEFAULT-FRAME
   ALIGN-L                                                              */
/* SETTINGS FOR FILL-IN cFileFrom IN FRAME DEFAULT-FRAME
   ALIGN-L                                                              */
/* SETTINGS FOR FILL-IN cFileTo IN FRAME DEFAULT-FRAME
   ALIGN-L                                                              */
/* SETTINGS FOR FILL-IN cTitle IN FRAME DEFAULT-FRAME
   ALIGN-L                                                              */
IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
THEN C-Win:HIDDEN = no.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME

 




/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON END-ERROR OF C-Win /* SHFileOperation Example */
OR ENDKEY OF {&WINDOW-NAME} ANYWHERE DO:
  /* This case occurs when the user presses the "Esc" key.
     In a persistently run window, just ignore this.  If we did not, the
     application would exit. */
  IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON WINDOW-CLOSE OF C-Win /* SHFileOperation Example */
DO:
  /* This event will close the window and terminate the procedure.  */
  APPLY "CLOSE":U TO THIS-PROCEDURE.
  RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME btnCopyFiles
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btnCopyFiles C-Win
ON CHOOSE OF btnCopyFiles IN FRAME DEFAULT-FRAME /* Copy Files */
DO:
define var lpFileOp     as  memptr  no-undo.
define var lpTitle      as  memptr  no-undo.
define var lpFileFrom   as  memptr  no-undo.
define var lpFileTo     as  memptr  no-undo.

  do with frame {&frame-name}:

    assign
    set-size(lpFileOp)        = 32
    set-size(lpTitle)         = length(cTitle:screen-value) + 1
    set-size(lpFileFrom)      = length(cFileFrom:screen-value) + 3
    set-size(lpFileTo)        = length(cFileTo:screen-value) + 3
    put-string(lpTitle,1)     = cTitle:screen-value
  
    /* double null terminate list */
    put-string(lpFileFrom,1)  = cFileFrom:screen-value
    put-byte(lpFileFrom,length(cFileFrom:screen-value) + 1) = 0
    put-byte(lpFileFrom,length(cFileFrom:screen-value) + 2) = 0
  
    /* double null terminate list */
    put-string(lpFileTo,1)    = cFileTo:screen-value
    put-byte(lpFileTo, length(cFileTo:screen-value) + 1) = 0
    put-byte(lpFileTo, length(cFileTo:screen-value) + 2) = 0
  
    /* set up SHFileOP Structure */
    put-long(lpFileOp,1)      = 0
    put-long(lpFileOp,5)      = {&FO_COPY}
    put-long(lpFileOp,9)      = get-pointer-value(lpFileFrom)
    put-long(lpFileOp,13)     = get-pointer-value(lpFileTo)
    put-long(lpFileOp,17)     = {&FOF_SIMPLEPROGRESS}
    put-long(lpFileOp,19)     = 0
    put-long(lpFileOp,23)     = 0
    put-long(lpFileOp,27)     = get-pointer-value(lpTitle)
    .

  end. 

  run SHFileOperationA( input  get-pointer-value(lpFileOp),
                        output iRetCode).
  
  /* dealloacte memory */
  assign                        
  set-size(lpFileOp)        = 0
  set-size(lpTitle)         = 0
  set-size(lpFileFrom)      = 0
  set-size(lpFileTo)        = 0.

  if iRetCode > 0 then
    ShowError(iRetCode).
  
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME btnDeleteFile
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btnDeleteFile C-Win
ON CHOOSE OF btnDeleteFile IN FRAME DEFAULT-FRAME /* Delete Files */
DO:
define var lpFileOp     as  memptr  no-undo.
define var lpTitle      as  memptr  no-undo.
define var lpFileToDelete     as  memptr  no-undo.

  do with frame {&frame-name}:

    assign
    set-size(lpFileOp)        = 32
    set-size(lpTitle)         = length(cTitle:screen-value + '(Removing)') + 1
    set-size(lpFileToDelete)  = length(cDeleteFile:screen-value) + 3
    put-string(lpTitle,1)     = cTitle:screen-value + '(Removing)'
  
    /* double null terminate list */
    put-string(lpFileToDelete,1)    = cDeleteFile:screen-value
    put-byte(lpFileToDelete, length(cDeleteFile:screen-value) + 1) = 0
    put-byte(lpFileToDelete, length(cDeleteFile:screen-value) + 2) = 0
  
    /* set up SHFileOP Structure */
    put-long(lpFileOp,1)      = 0
    put-long(lpFileOp,5)      = {&FO_DELETE}
    put-long(lpFileOp,9)      = get-pointer-value(lpFileToDelete)
    put-long(lpFileOp,13)     = 0
    put-long(lpFileOp,17)     = {&FOF_SIMPLEPROGRESS}
    put-long(lpFileOp,19)     = 0
    put-long(lpFileOp,23)     = 0
    put-long(lpFileOp,27)     = get-pointer-value(lpTitle)
    .

  end. 

  run SHFileOperationA( input  get-pointer-value(lpFileOp),
                        output iRetCode).

  /* dealloacte memory */
  assign                        
  set-size(lpFileOp)        = 0
  set-size(lpTitle)         = 0
  set-size(lpFileToDelete)  = 0.
  
  if iRetCode > 0 then
    ShowError(iRetCode).
  
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK C-Win 


/* ***************************  Main Block  *************************** */

/* Set CURRENT-WINDOW: this will parent dialog-boxes and frames.        */
ASSIGN CURRENT-WINDOW                = {&WINDOW-NAME} 
       THIS-PROCEDURE:CURRENT-WINDOW = {&WINDOW-NAME}.

/* The CLOSE event can be used from inside or outside the procedure to  */
/* terminate it.                                                        */
ON CLOSE OF THIS-PROCEDURE 
   RUN disable_UI.

/* Best default for GUI applications is...                              */
PAUSE 0 BEFORE-HIDE.

/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
  RUN enable_UI.
  IF NOT THIS-PROCEDURE:PERSISTENT THEN
    WAIT-FOR CLOSE OF THIS-PROCEDURE.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI C-Win _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Delete the WINDOW we created */
  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
  THEN DELETE WIDGET C-Win.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI C-Win _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY cFileFrom cFileTo cTitle cDeleteFile 
      WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.
  ENABLE RECT-1 cFileFrom cFileTo cTitle cDeleteFile btnCopyFiles btnDeleteFile 
      WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.
  {&OPEN-BROWSERS-IN-QUERY-DEFAULT-FRAME}
  VIEW C-Win.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* ************************  Function Implementations ***************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION ShowError C-Win 
FUNCTION ShowError RETURNS LOGICAL
  (INPUT piErrorCode    AS  INTEGER):
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  
------------------------------------------------------------------------------*/

  define var cErrMsg    as  char    no-undo.
  
  cErrMsg = fill(' ', 300).
  run FormatMessageA
    ( 512 + 4096, /* = format_message_ignore_inserts +
                       foramt_message_from_system  */
      0,
      piErrorCode,
      0,
      output cErrMsg,
      length(cErrMsg),
      0).
                     
  message SUBSTITUTE('Error, &1, encountered. &2, &3',
                     piErrorCode,
                     chr(10),
                     cErrMsg)
                     view-as alert-box.
                     
  RETURN TRUE.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME



